local world = require 'logic.world.world'
local fsm = require 'logic.state.finite_state_machine'

local update = {}

function update.load(gameState)
  gameState.title = "O.o"
  fsm.load(gameState)
  world.load(gameState)
end

function update.update(gameState)
  local player = gameState.physics.player
  if player then
    if gameState.inputs.up.down then
      local angle = player:getAngle() + math.pi/2
      local dx, dy = 50*math.cos(angle), 50*math.sin(angle)
      player:applyLinearImpulse(dx, dy)
    end
    if gameState.inputs.left.down then
      player:applyAngularImpulse(-2000)
    end
    if gameState.inputs.right.down then
      player:applyAngularImpulse(2000)
    end
    if gameState.inputs.shoot.released then
      player:shoot()
    end
  end
  world.update(gameState)
  fsm.update(gameState)
end

return update
